catch {wm title . "IFT based Connected Operators: Filtering + Segmentation"}

wm minsize . 280 20

set GLOBAL 1
set LOCAL  0
set scope $GLOBAL

set CUT 1
set FILL 0
set filterType $CUT

set LINES  0
set MAXREG 1
set MINREG 2
set FRAME 3

set seedsType $MAXREG
set segmSeedsType $seedsType

set original  "__temp_original.pgm"
set refLevels "__temp_refLevel.pgm"
set gradOriginal "__temp_gradOriginal.pgm"  
set gradRefLevels "__temp_gradRefLevels.pgm" 
set imposeSegm    "__temp_imposeSegm.pgm"
set workOriginal $original
set workRefLevels $refLevels

set goWasRun 0

set nRoots 0
set cor(1) red
set cor(2) green
set cor(3) blue

#########################
#prepara o quadro do menu
#########################

frame .mbar -relief raised -bd 2
menubutton .mbar.file -text File -underline 0 -menu .mbar.file.menu
pack .mbar.file  -side left
pack .mbar -fill x

menu .mbar.file.menu -tearoff 0
.mbar.file.menu add command -label "Open Image" -command {LoadMaskImage}
.mbar.file.menu add command -label "Open Reference Levels Image" -command {LoadMarkerImage}
.mbar.file.menu add separator
.mbar.file.menu add command -label "Save Filtered Image" -command {SaveImage "filtered.pgm"}
.mbar.file.menu add command -label "Save Labels Image" -command {SaveImage "labels.pgm"}
.mbar.file.menu add separator
.mbar.file.menu add command -label Exit -command {CleanUpAndExit }

tk_menuBar .mbar .mbar.file .mbar.options
focus .mbar


############################
#prepara o quadro de opcoes
############################
frame .options -relief groove 
pack .options -expand true -side bottom 

frame .options.set -relief groove -borderwidth 4

frame .options.set.prefilter -relief groove -borderwidth 4
#-relief sunken -borderwidth 4
checkbutton .options.set.prefilter.b1 -text "use gradient" -variable useGrad -command {Grad}
checkbutton .options.set.prefilter.b2 -text "show segmentation" -variable showSegm -command {ShowSegm}
pack .options.set.prefilter.b1 .options.set.prefilter.b2 -side bottom -fill both -expand true

frame .options.set.clear -relief groove -borderwidth 4
#-relief ridge -borderwidth 4
button .options.set.clear.b1 -text "clear seeds" -command {ClearSeeds }
button .options.set.clear.b2 -text "reference levels" -command {source prefilter.tcl}
pack .options.set.clear.b1 .options.set.clear.b2 -expand true -side bottom -fill both

frame .options.set.scope -relief groove -borderwidth 4
radiobutton .options.set.scope.global -text "global" -variable scope -value $GLOBAL
radiobutton .options.set.scope.local -text "local" -variable scope -value $LOCAL
pack .options.set.scope.local .options.set.scope.global -expand true -side bottom -fill both


frame .options.set.type -relief groove -borderwidth 4
radiobutton .options.set.type.cut -text "cutting-off domes" -variable filterType -value $CUT
radiobutton .options.set.type.fill -text "filling-up basins" -variable filterType -value $FILL
pack .options.set.type.fill .options.set.type.cut -expand true -side bottom -fill both


frame .options.seeds -relief groove -borderwidth 4
label .options.seeds.label -text "seeds: "
radiobutton .options.seeds.lines -text "lines" -variable seedsType -value $LINES -command {SeedTypeChanged}
radiobutton .options.seeds.maxReg -text "regional maxima" -variable seedsType -value $MAXREG -command {SeedTypeChanged}
radiobutton .options.seeds.minReg -text "reginal minima" -variable seedsType -value $MINREG -command {SeedTypeChanged}
radiobutton .options.seeds.frame -text "frame" -variable seedsType -value $FRAME -command {SeedTypeChanged}
pack .options.seeds.label .options.seeds.lines .options.seeds.maxReg .options.seeds.minReg .options.seeds.frame -expand true -fill both -side left


frame .options.go
button .options.go.b1 -text "GO" -command {Go}
button .options.go.b2 -text "exit" -command {CleanUpAndExit }
pack .options.go.b1 .options.go.b2 -expand true -fill both -side left

pack .options.set.prefilter .options.set.type .options.set.scope -expand true -side left -fill y
pack .options.set.clear -expand true -fill y -side right
pack .options.go .options.seeds .options.set -expand true -side bottom -fill both

bind . <Key-Return> {Go}



######################
#procedimentos locais
######################

proc Grad {} {
    global useGrad grad original gradOriginal gradRefLevels refLevels workOriginal workRefLevels

    if {$useGrad == 1} {
	set workOriginal $gradOriginal
	set workRefLevels $gradRefLevels

	ShowWait .frameOriginal
	eval "exec morph $original $workOriginal grad"
	eval "exec morph $refLevels $workRefLevels grad"
	ShowNormalCursor .frameOriginal	
    } else {
	set workOriginal $original
	set workRefLevels $refLevels
    }
}

proc GetRoots {} {
    global but nRoots cor seedsType root    
    set but 0
  
    
    bind .frameOriginal.c1 <ButtonPress> {set seedsType $LINES; incr nRoots;  imgOriginal put [list [list $cor(%b)]] -to %x %y; set but %b; set root($nRoots) "%x %y $but"}
    bind .frameOriginal.c1 <Motion> {if {$but} {incr nRoots; imgOriginal put [list [list $cor($but)]] -to %x %y; set root($nRoots) "%x %y $but"}}
    bind .frameOriginal.c1 <ButtonRelease> {set but 0}
    bind .frameOriginal.c1 <Shift-ButtonPress> {Go }
}


proc SeedTypeChanged {} {
    ShowSegm
}

proc ShowSegm {} {
    global goWasRun showSegm imposeSegm original segmSeedsType seedsType

    if {[expr $showSegm != 1 || $goWasRun == 0 || $segmSeedsType != $seedsType]} {
	DisplayMaskImage $original
    } else {
	eval "exec morph $original $imposeSegm showsegm labels.pgm 255 255 0"
	DisplayMaskImage $imposeSegm
    }
}


proc Go {} {
    global nRoots root seedsType segmSeedsType LINES MAXREG MINREG FRAME useGrad workOriginal workRefLevels filterType scope showSegm imposeSegm original goWasRun

#    set goWasRun 1

#    puts "Go..."

    if {$seedsType == $LINES} {
	if {$nRoots > 0} { 
	    set out [open ift_roots w] 
	    puts $out "$nRoots"
	    for {set i 1} {$i <= $nRoots} {incr i} {
		puts $out "$root($i)"
	    }
	    close $out
	} else {	
	    return
	}
    } elseif {$seedsType == $MAXREG} {
	eval "exec calcRoots $workRefLevels ift_roots regMax 0 100000"
    } elseif {$seedsType == $MINREG} {
	eval "exec calcRoots $workRefLevels ift_roots regMin 0 100000"
    } elseif {$seedsType == $FRAME} {
	eval "exec calcRoots $workRefLevels ift_roots frame 1 2"
    }

#    puts"exec filter2 $workOriginal $workRefLevels $filterType $scope ift_roots" 
    eval "exec filter2 $workOriginal $workRefLevels $filterType $scope ift_roots" 

    set goWasRun 1

    if {$showSegm == 1} {
	set segmSeedsType $seedsType
	ShowSegm
    }


    source posfilter.tcl
    focus .
    
}


proc ClearSeeds {} {
    global nRoots original marker roots_type segmSeedsType

    if {[file exists ift_roots]} {
	eval "exec rm -f ift_roots"
    }
    
    set segmSeedsType -1
    set nRoots 0
    DisplayMaskImage $original
    GetRoots
}


proc CleanUpAndExit {} {
    global original refLevels gradOriginal gradRefLevels imposeSegm

    if {[file exists $original]} {
	eval "exec rm $original"
    }

    if {[file exists $refLevels]} {
	eval "exec rm $refLevels"
    }

    if {[file exists $gradOriginal]} {
	eval "exec rm $gradOriginal"
    }

    if {[file exists $gradRefLevels]} {
	eval "exec rm $gradRefLevels"
    }

    if {[file exists $imposeSegm]} {
	eval "exec rm $imposeSegm"
    }

    if {[file exists "filtered.pgm"]} {
	eval "exec rm filtered.pgm"
    }

    if {[file exists "labels.pgm"]} {
	eval "exec rm labels.pgm"
    }

    exit
}


proc LoadMaskImage { } {
    global original refLevels nRoots goWasRun useGrad showSegm workOriginal workRefLevels

    set types {
	{ {Only Files} {.pgm .p5} }
    }
    set temp [tk_getOpenFile -filetypes $types ]
    set ext [lindex [split $original .] 1]
    #ProcessImage $temp $temp $roots_type $influence_zone

    set nRoots 0
    set goWasRun 0
    set useGrad 0
    set showSegm 0

    DisplayMaskImage $temp
    
    eval "exec cp $temp $original"
    eval "exec cp $temp $refLevels"

    set workOriginal $original
    set workRefLevels $refLevels
}

proc SaveImage {img} {
    global original refLevels nRoots goWasRun useGrad showSegm workOriginal workRefLevels

    set types {
	{ {} {.pgm} }
    }
    set temp [tk_getSaveFile -filetypes $types ]
    set ext [lindex [split $temp .] 1]
    if {$ext == ""} {
       set temp "$temp.pgm"
    }
    puts "will save $temp"

    eval "exec cp $img $temp"
}




proc DisplayMaskImage original  {
    global nRoots root cor

    destroy .frameOriginal
    image create photo imgOriginal -file $original
    set w [image width imgOriginal]
    set h [image height imgOriginal]
    frame .frameOriginal -width 2
    canvas .frameOriginal.c1 -width $w -height $h
    .frameOriginal.c1 create image [expr $w/2] [expr $h/2] -image imgOriginal -tag ImagemOriginal

#    ShowNormalCursor    
#    .frame2 config -cursor left_ptr

    pack .frameOriginal.c1 -side left 
    pack .frameOriginal -side top
    #    bind .frameOriginal <Button-3>        {exit}
    
    if {$nRoots > 0} {
	for {set i 1} {$i <= $nRoots} {incr i} {
	    imgOriginal put [list [list $cor([lindex $root($i) 2])]] -to [lindex $root($i) 0] [lindex $root($i) 1]
#	    puts ">>>> $root(1) [lindex $root($i) 2]"
	}

    }
    ShowNormalCursor .frameOriginal

    GetRoots
}


proc ShowWait {frame} {
    $frame config -cursor watch
    update idletasks
}

proc ShowNormalCursor {frame} {
    $frame config -cursor pencil
    update idletasks
}

#########
#execucao
#########


if {$argc == 1} {
    eval "exec cp [lindex $argv 0] $original"
    eval "exec cp [lindex $argv 0] $refLevels"
} elseif {$argc == 2} {   
    eval "exec cp [lindex $argv 0] $original"
    eval "exec cp [lindex $argv 1] $refLevels"
} else {
    puts "wish filter.tcl <input image> <optional reference levels image"
    CleanUpAndExit
}

DisplayMaskImage $original
GetRoots